import random
from osgeo import gdal

# so that we have always the same random :-)
random.seed(0)

ds = gdal.GetDriverByName('GTiff').Create('foo.tif', 512, 256, 2, options = ['COMPRESS=DEFLATE', 'TILED=YES'])

# Write first tile so that its byte count of that tile is 2048 (a multiple of 1024)
adjust = 1254
data = ''.join(['0' for i in range(65536 - adjust)]) + ''.join([('%c' % random.randint(0,255)) for i in range(adjust)])
ds.GetRasterBand(1).WriteRaster(0, 0, 256, 256, data)

# Second tile will be implicitely written at closing, or we could write any content

ds = None

ds = gdal.Open('foo.tif', gdal.GA_Update)

# Will adjust tif_rawdatasize to TIFFroundup_64((uint64)size, 1024) = TIFFroundup_64(2048, 1024) = 2048
ds.GetRasterBand(1).ReadRaster(0, 0, 256, 256)

# The new bytecount will be greater than 2048
data = ''.join([('%c' % random.randint(0,255)) for i in range(256 * 256)])
ds.GetRasterBand(1).WriteRaster(0, 0, 256, 256, data)

# Make sure that data is written now
ds.FlushCache()

# Oops, without fix, the second tile will have been overwritten and an error will be emitted
ds.GetRasterBand(1).ReadRaster(256, 0, 256, 256)

ds = None
